Program Kbc;    (* Modification du clavier pour dessiner des cadres *)
                (* JC Meier 5/95   pour Turbo-Pascal 6-7            *)

{$M 1100,0, 0}   (* Limitation maximale de l'occupation mmoire *)

USES Dos;

CONST
  Nb_Touches = 11; (* Nombre de touches redfinies : 11 ici *)

  Seg_TC = $40; (* Adresse mmoire du Tampon Clavier, Segment et Ofset *)
  Ofs_TC = $1A;

VAR
    AC,  (* Ancien Code ASCII de la touche *)
    NC,  (* Nouveau Code ASCII de la touche, trait simple *)
    NC2, (* Nouveau Code ASCII de la touche, trait double *)
    SC   (* Scan Code de la touche *)
         : ARRAY[1..Nb_Touches] OF BYTE;

    Ancienne_Int09 : Pointer;


PROCEDURE Modifie_Clavier; (* table de raffectation pour le pav numrique *)
                           (* lorsque Arrt dfilement est actif            *)
(*
          Ŀ Ŀ Ŀ        Ŀ Ŀ Ŀ
          7 ڳ 8 ³ 9         7 ɳ 8 ˳ 9 
                      
          Ŀ Ŀ Ŀ        Ŀ Ŀ Ŀ
          4 ó 5 ų 6         4 ̳ 5 γ 6 
                      
          Ŀ Ŀ Ŀ        Ŀ Ŀ Ŀ
          1  2  3 ٳ        1 ȳ 2 ʳ 3 
                      
          Ŀ Ŀ        Ŀ Ŀ
          0        .         0        . 
                    

*)

BEGIN
  AC[1] := 55; NC[1]  := 218 ; NC2[1] := 201 ; SC[1] := 71;
  AC[2] := 56; NC[2]  := 194 ; NC2[2] := 203 ; SC[2] := 72;
  AC[3] := 57; NC[3]  := 191 ; NC2[3] := 187 ; SC[3] := 73;

  AC[4] := 52; NC[4]  := 195 ; NC2[4] := 204 ; SC[4] := 75;
  AC[5] := 53; NC[5]  := 197 ; NC2[5] := 206 ; SC[5] := 76;
  AC[6] := 54; NC[6]  := 180 ; NC2[6] := 185 ; SC[6] := 77;

  AC[7] := 49; NC[7]  := 192 ; NC2[7] := 200 ; SC[7] := 79;
  AC[8] := 50; NC[8]  := 193 ; NC2[8] := 202 ; SC[8] := 80;
  AC[9] := 51; NC[9]  := 217 ; NC2[9] := 188 ; SC[9] := 81;

  AC[10] := 48; NC[10]  := 196 ; NC2[10] := 205 ; ; SC[10] := 82;
  AC[11] := 46; NC[11]  := 179 ; NC2[11] := 186 ; ; SC[11] := 83;

END;

FUNCTION CapsOn : BOOLEAN; (* Teste si le verrouillage numrique est actif *)
BEGIN
  CapsOn :=  (Mem[$40:$17] AND $40) <> 0;
END;

FUNCTION ScrollOn : BOOLEAN; (* Teste si Arrt dfilement est actif *)
BEGIN
  ScrollOn := (Mem[$40:$17] AND $10) <> 0;
END;

PROCEDURE Nouvelle_Int09 (flags,cs,ip,ax,bx,cx,si,di,ds,es,bp : WORD);
INTERRUPT;

VAR i, j     : INTEGER;
    A_Trouve : BOOLEAN;
BEGIN
  ASM
    Pushf
    Call Ancienne_Int09     (* Appel  l'ancienne interruption *)
    Cli                     (* interdiction des interruptions  *)
  END;
  j := MEMW[Seg_TC:Ofs_TC]; (* Adresse mmoire du premier caractre *)
  A_Trouve := False;
  i := 0;
  REPEAT
    INC(i);
    IF (MEM[Seg_TC:j] = AC[i])
    AND (MEM[Seg_TC:j + 1] = SC[i])

    (* Si le caractre qui vient d'tre mis au dbut de la mmoire  *)
    (* tampon est un de ceux qui doivent tre modifis et que Arrt *)
    (* Dfilement est actif, alors on le modifie et on le replace   *)

    AND ScrollOn THEN
    BEGIN
      A_Trouve := True;
      IF NOT Capson THEN    (* Trac simple si l'on est en minuscules *)
      MEM[Seg_TC:j] := NC[i]
      ELSE                  (* Trac double si l'on est en majuscules *)
      MEM[Seg_TC:j] := NC2[i];
    END;
  UNTIL A_Trouve OR (i = Nb_Touches);
  ASM
    Sti  (* Rtablissement des interruptions *)
  END;
END;

BEGIN
  Modifie_Clavier;
  GetIntVec($09, Ancienne_Int09);  (* Sauvegarde de l'ancienne interruption *)
  SetIntVec($09, @Nouvelle_Int09); (* Mise en place de la nouvelle          *)
  Write('                        KBC est maintenant rsidant . . .');
  Keep(0);  (* Sortie en laissant le programme rsidant *)
END.