DEFINT A-Z
DECLARE FUNCTION ALIGN$ (chaine$, largeur)
DECLARE FUNCTION CENTER$ (chaine$, largeur)
DECLARE FUNCTION INP$ (chaine$, position, longeur)

DECLARE FUNCTION FormateColonne$ (enr, col, longeur)
DECLARE FUNCTION ModifieColonne (position, longeur, n)
DECLARE FUNCTION LitColonne$ (n)
DECLARE SUB EcritColonne (n, chaine$)

DECLARE FUNCTION LitEnr (numero)
DECLARE SUB ResetEnr (SelCat)
DECLARE SUB EcritEnr (numero)

DECLARE FUNCTION OuvreFichier (name$)
DECLARE SUB FermeFichier (Fichier$)

DECLARE FUNCTION ChoisisCategorie ()
DECLARE SUB Interface (DernierFichier$)


CONST IDstring = "DISK_CAT  "                '** Identificateur d'un fichier
CONST VersionNum = 2                        '** Numro de version du fichier

TYPE EnTete
  ID      AS STRING * 10         'IDentificateur du fichier
  version AS INTEGER             'Numro de version
  debut   AS INTEGER             'L o commencent les enregistrements
  nbenr   AS INTEGER             'Nombre d'enregistrement
  catName AS STRING * 40         'Nom du catalogue
END TYPE

TYPE Enregistrement
  nom     AS STRING * 20         'Nom du soft
  nbDisk  AS INTEGER             'Nombre de disks
  version AS STRING * 4          'Version du soft
  Categor AS INTEGER             'Catgorie
  Note    AS INTEGER             'Notation sur le logiciel
  comment AS STRING * 40         'Commentaire associ
END TYPE

DIM SHARED BufEnr AS Enregistrement          '** Contient l'enregistrement lu
DIM SHARED head AS EnTete                   '** Contient le header du fichier
DIM SHARED SelCat AS INTEGER                '** Catgorie choisie et affiche

DIM SHARED MaxCategor AS INTEGER            '** Nombre de catgories dfinies
DIM SHARED NomCategor(1 TO 100) AS STRING * 40         '** Nom des catgories

RESTORE Categories                            '** Lit les noms des catgories
FOR i = 1 TO 100                                            '** 100 maximum..
  READ NomCategor(i)
  IF RTRIM$(NomCategor(i)) = "#FIN#" THEN EXIT FOR ELSE MaxCategor = MaxCategor + 1
NEXT

Interface "Sans_nom.cat"                 '** Dmarrer en ouvrant Sans_nom.cat

Colonnes:
CONST MaxCol = 5                                '** Nom des champs du fichier
DATA 1, 22, "Nom"
DATA 24, 6, "Ver."
DATA 31, 6, "nbHD"
DATA 38, 5, "/20"
DATA 44, 37, "Commentaires"
'*** Position, longeur, nom

Categories:                                         '** Nom des catgories...
DATA "Utilitaires Windows"
DATA "Utilitaires Dos"
DATA "Utilitaires Disque Dos"
DATA "Utilitaires Disque Win"
DATA "Bureautique"
DATA "Dessin"
DATA "Zizik"
DATA "Gags"
DATA "Jeux Rflexion"
DATA "Jeux Arcade"
DATA "Jeux Aventure"
DATA "Programmation"
DATA "Drivers"
DATA "#FIN#"

               '** ALIGNe une chaine de texte  gauche sur une largeur donne
FUNCTION ALIGN$ (chaine$, largeur)
 
  ALIGN$ = LEFT$(chaine$ + SPACE$(largeur), largeur)

END FUNCTION

                                 '** Centre une chaine sur une largeur donne
FUNCTION CENTER$ (chaine$, largeur)
 
  chaine$ = SPACE$(largeur \ 2) + chaine$ + SPACE$(largeur \ 2)
  CENTER$ = MID$(chaine$, (LEN(chaine$) - largeur + 2) \ 2, largeur)

END FUNCTION

FUNCTION ChoisisCategorie                    '** Renvoie la catgorie choisie

  COLOR 14, 5                 '** Affiche les bords :
  LOCATE 7, 19: PRINT ""; STRING$(40, ""); "";
  LOCATE 18, 19: PRINT ""; STRING$(40, ""); "";

  pDep = 1                                  '** Affiche une boite de dialogue
  pBase = 0                   '** Permettant de choisir la catgorie affiche

  DO
    FOR i = 1 TO 10
      IF (i + pBase) > MaxCategor THEN
        S$ = SPACE$(40)
      ELSE
        S$ = CENTER$(RTRIM$(NomCategor$(i + pBase)), 40)
      END IF
      IF i = pDep THEN COLOR 15, 0 ELSE COLOR 14, 5
      LOCATE 7 + i, 19
      PRINT ""; S$; "";
    NEXT

    DO: k$ = INKEY$: LOOP WHILE k$ = ""
    SELECT CASE ASC(k$)
      CASE 27: EXIT DO
      CASE 13: ChoisisCategorie = pDep + pBase: EXIT DO
      CASE 0:  SELECT CASE ASC(RIGHT$(k$, 1))
                 CASE 72: IF pDep > 1 THEN pDep = pDep - 1 ELSE IF pBase > 0 THEN pBase = pBase - 1 ELSE BEEP
                 CASE 80: IF (pDep + pBase) < MaxCategor THEN IF pDep < 10 THEN pDep = pDep + 1 ELSE pBase = pBase + 1 ELSE BEEP
               END SELECT
    END SELECT
 
  LOOP                                                      '** Liste type...
 
END FUNCTION

SUB EcritColonne (n, chaine$)

  SELECT CASE n                                       '** Ecrit un des champs
    CASE 1: BufEnr.nom = chaine$                      '** De l'enregistrement
    CASE 2: BufEnr.version = chaine$                  '** via un numro de
    CASE 3: BufEnr.nbDisk = VAL(chaine$)              '** colonne (n)
    CASE 4: BufEnr.Note = VAL(chaine$)
    CASE 5: BufEnr.comment = chaine$
  END SELECT

END SUB

                                        '** Ecrit l'enregistrement en mmoire
SUB EcritEnr (numero)                   '** sur le disque

  PUT 1, head.debut + (numero - 1) * LEN(BufEnr), BufEnr
  
END SUB

SUB FermeFichier (Fichier$)

  Detruire = LOF(1) = 0                                  '** Ferme le fichier
  CLOSE 1                                     '** Le supprimme ventuellement
  IF Detruire THEN KILL Fichier$                       '** S'il fait 0 octets

END SUB

FUNCTION FormateColonne$ (enr, col, longeur)

  IF LitEnr(enr) THEN
   
    FormateColonne$ = " " + ALIGN$(LitColonne$(col), longeur - 2) + " "
 
  ELSE
   
    FormateColonne$ = SPACE$(longeur)
 
  END IF
                                  '** Renvoie une cellule pr-formate, prte
END FUNCTION                                                   '** a afficher

FUNCTION INP$ (chaine$, position, longeur)                '** Remplace INPUT$

  texte$ = chaine$
  DO
    LOCATE , position, 0
    PRINT ALIGN$(texte$, longeur);
    IF bye THEN LOCATE , , 0: EXIT DO ELSE LOCATE , position + LEN(texte$), 1

    DO: k$ = INKEY$: LOOP WHILE k$ = ""

    SELECT CASE ASC(k$)
      CASE 13: INP$ = texte$: bye = 1                '** ENTER
      CASE 27: INP$ = chaine$: bye = 1               '** ECHAP
      CASE 8: IF LEN(texte$) > 0 THEN texte$ = LEFT$(texte$, LEN(texte$) - 1) ELSE BEEP
      CASE 32 TO 255: IF LEN(texte$) < longeur THEN texte$ = texte$ + k$ ELSE BEEP
    END SELECT

  LOOP
 
END FUNCTION

SUB Interface (DernierFichier$)

  '** Liste des numros d'enregistrements correspondant  la catgorie
  '** indique par SelCat
  DIM EnrList(1 TO 2000) AS INTEGER

  '** Position, longeur et nom de chaque colonne
  DIM poscol(1 TO MaxCol) AS INTEGER
  DIM lencol(1 TO MaxCol) AS INTEGER
  DIM NomCol(1 TO MaxCol) AS STRING
 
  RESTORE Colonnes                                       '** Lit les colonnes
  FOR i = 1 TO MaxCol: READ poscol(i), lencol(i), NomCol(i): NEXT
 
  IF OuvreFichier(DernierFichier$) = 0 THEN EXIT SUB     '** Ouvre le fichier
 
  LOCATE 3, 1                                                   '** Interface
  COLOR 14, 0
  FOR i = 1 TO MaxCol
    PRINT " "; ALIGN$(NomCol(i), lencol(i) - 2); " "; "";
  NEXT
  COLOR 14, 5
  LOCATE 25, 1
  PRINT " F2 Ouvrir/Nouveau   F3 Catgories   F4 Nommer    Modifier    Dplacement ";

  ChangeCat = 1                                            '** Initialisation
  ChangeTitreBar = 1
  SelCat = 1
 
  DO

    IF ChangeCat THEN                        '** La catgorie a t change ?
      Maxlist = 0
      FOR i = 1 TO head.nbenr                      '** Oui, refaire une liste
        IF LitEnr(i) THEN                     '** de numros d'enregistrement
          IF BufEnr.Categor = SelCat THEN
            Maxlist = Maxlist + 1
            EnrList(Maxlist) = i
          END IF
        END IF
      NEXT
      FOR i = Maxlist + 1 TO 100
        EnrList(i) = 0
      NEXT
      Maxlist = Maxlist + 1
      pBase = 0: oBase = 0
      pDep = 1: oDep = 1
      pCol = 1: oCol = 1
      ChangeBase = 1
      ChangeCategorBar = 1
      ChangeCat = 0
    END IF

    IF ChangeTitreBar THEN                 '** Rafficher la barre de titre ?
      LOCATE 1, 1
      COLOR 14, 5
      PRINT CENTER$(DernierFichier$ + " - " + RTRIM$(head.catName), 80)
      ChangeTitreBar = 0
    END IF

    IF ChangeCategorBar THEN           '** Rafficher la barre de catgorie ?
      LOCATE 2, 1
      COLOR 0, 7
      PRINT ALIGN$(" Catgorie : " + NomCategor(SelCat), 80)
      ChangeCategorBar = 0
    END IF

    IF (oBase <> pBase) OR ChangeBase THEN            '** Dplacement total ?
      COLOR 0, 7                                       '("scrolling" d'cran)
      LOCATE 4, 1                                        '--> Tout rafficher
      FOR i = 1 TO 21
        okEnr = LitEnr(EnrList(i + pBase))
        FOR j = 1 TO MaxCol
          IF okEnr THEN
            PRINT " "; ALIGN$(LitColonne$(j), lencol(j) - 2); " ";
          ELSE
            PRINT SPACE$(lencol(j));
          END IF
          IF j <> MaxCol THEN PRINT "";
      NEXT j, i
      oBase = pBase
      ChangeBase = 0
      ChangeDep = 1
    END IF
   
    IF (oDep <> pDep) OR (oCol <> pCol) OR ChangeDep THEN
                                                   '** Dplacement du curseur
      COLOR 0, 7                                      '** Rafficher l'ancien
      LOCATE 3 + oDep, poscol(oCol)
      PRINT FormateColonne$(EnrList(oDep + pBase), oCol, lencol(oCol));
     
      COLOR 14, 1                                              '** Le nouveau
      LOCATE 3 + pDep, poscol(pCol)
      PRINT FormateColonne$(EnrList(pDep + pBase), pCol, lencol(pCol));
     
      oDep = pDep
      oCol = pCol
      ChangeDep = 0
    END IF

    DO: k$ = INKEY$: LOOP WHILE k$ = ""
    SELECT CASE ASC(k$)
     
      CASE 27: EXIT DO                                            '** Quitter
     
      CASE 0:  SELECT CASE ASC(RIGHT$(k$, 1))
                 '** HAUT, monter
                 CASE 72: IF pDep > 1 THEN pDep = pDep - 1 ELSE IF pBase > 0 THEN pBase = pBase - 1 ELSE BEEP
                
                 '** BAS, descendre dans la limite du possible
                 CASE 80: IF pDep + pBase < Maxlist THEN IF pDep < 21 THEN pDep = pDep + 1 ELSE pBase = pBase + 1 ELSE BEEP
                
                 '** GAUCHE, dplacer le curseur vers la colonne de gauche
                 CASE 75: IF pCol > 1 THEN pCol = pCol - 1 ELSE pCol = MaxCol

                 '** DROITE, idem vers la droite
                 CASE 77: IF pCol < MaxCol THEN pCol = pCol + 1 ELSE pCol = 1

                 '** F2 : Charge un autre fichier
                 CASE 60: LOCATE 2, 1: COLOR 0, 7: PRINT " Fichier : "; : COLOR 8, 7
                          S$ = INP$(DernierFichier$, POS(0), 40)
                          IF S$ <> DernierFichier$ THEN
                            FermeFichier DernierFichier$
                            IF OuvreFichier(S$) = 0 THEN EXIT DO
                            DernierFichier$ = S$
                            ChangeCat = 1
                            ChangeTitreBar = 1
                          ELSE ChangeCategorBar = 1
                          END IF
                
                 '** F3 : Changer la catgorie affiche
                 CASE 61: ChangeBase = 1: i = ChoisisCategorie: IF i > 0 THEN SelCat = i: ChangeCat = 1
                
                 '** F4 : Modifier le nom long du fichier
                 CASE 62: LOCATE 2, 1: COLOR 0, 7: PRINT " Nom du catalogue : "; : COLOR 8, 7
                          head.catName = INP$(RTRIM$(head.catName), POS(0), 40)
                          PUT 1, 1, head
                          ChangeCategorBar = 1
                          ChangeTitreBar = 1
               END SELECT
     
              '** ENTREE : Modifier la cellule
      CASE 13: IF LitEnr(EnrList(pDep + pBase)) = 0 THEN ResetEnr SelCat
               LOCATE 3 + pDep, poscol(pCol)
               COLOR 14, 1
               IF ModifieColonne(poscol(pCol), lencol(pCol), pCol) THEN
                 IF pDep + pBase = Maxlist THEN
                   head.nbenr = head.nbenr + 1              '** Fin de liste,
                   EnrList(Maxlist) = head.nbenr     '** Rajouter une cellule
                   Maxlist = Maxlist + 1
                   EnrList(Maxlist) = 0
                   PUT 1, 1, head
                 END IF
                 EcritEnr (EnrList(pDep + pBase))
                 pCol = pCol + 1
                 IF pCol = MaxCol + 1 THEN
                   pCol = 1
                   IF pDep = 21 THEN pBase = pBase + 1 ELSE pDep = pDep + 1
                 END IF
               END IF

    END SELECT


  LOOP
 
  FermeFichier DernierFichier$

END SUB

FUNCTION LitColonne$ (n)          'n indique la colonne destination

  SELECT CASE n
    CASE 1: S$ = BufEnr.nom               '** Renvoie une chaine formate
    CASE 2: S$ = BufEnr.version           '** pour la colonne donne de
    CASE 3: S$ = STR$(BufEnr.nbDisk)      '** l'enregistrment en mmoire
    CASE 4: S$ = STR$(BufEnr.Note)
    CASE 5: S$ = BufEnr.comment
  END SELECT
  LitColonne$ = RTRIM$(LTRIM$(S$))

END FUNCTION

FUNCTION LitEnr (numero)

  '** Lit un enregistrement depuis le disque.
  '** Si le numro est invalide, LitEnr renvoie 0 et sinon 1.

  IF (numero > head.nbenr) OR (numero = 0) THEN
    LitEnr = 0
  ELSE
    GET 1, head.debut + (numero - 1) * LEN(BufEnr), BufEnr
    LitEnr = 1
  END IF


END FUNCTION

FUNCTION ModifieColonne (position, longeur, n)

  '** Permet de modifier les donnes d'une colonne
  '** Se charge de la lecture/criture sur disque
 
  ancien$ = LitColonne$(n)
  nouveau$ = INP$(ancien$, position + 1, longeur - 2)
  IF ancien$ <> nouveau$ THEN EcritColonne n, nouveau$
  ModifieColonne = ancien$ <> nouveau$

END FUNCTION

FUNCTION OuvreFichier (name$)

  OuvreFichier = 1
  OPEN name$ FOR BINARY AS 1                             '** Ouvre le fichier
  IF LOF(1) = 0 THEN                                       '** Fichier vide ?
    head.ID = IDstring
    head.version = VersionNum
    head.debut = LEN(head) + 1                            '** Nouveau fichier
    head.nbenr = 0
    head.catName = ""
  ELSE                                                 '** Fichier existant :
    GET 1, , head                                          '** Lire le header
    IF (head.ID <> IDstring) OR (head.version > VersionNum) THEN OuvreFichier = 0
  END IF

END FUNCTION

SUB ResetEnr (SelCat)
 
  BufEnr.nom = ""
  BufEnr.nbDisk = 1
  BufEnr.version = ""                 '** Remet l'enregistrement mmoire  0.
  BufEnr.Categor = SelCat
  BufEnr.Note = 10
  BufEnr.comment = ""

END SUB

