;*****************************************************************************
;*	Programme du secteur de partition de mon disque dur
;*
;* (C) 1990 American Megatrends Inc


IDEAL

STRUC	PART_ENTRY			; Structure d'une entre de la table
	State		DB	0	; de partition
	StartHead	DB	0
	StartSector	DW	0
	Type		DB	0
	EndHead		DB	0
	EndSector	DW	0
	FirstSector	DD	0
	NbSector	DD	0
ENDS


BIOS_BOOT_OFF	EQU	7C00h	; adresse ou le BIOS charge le boot
NEW_BOOT_OFF	EQU	600h	; adresse ou l'on dplace le boot
BOOT_SIZE	EQU	512	; taille du boot secteur
NB_PART		EQU	4	; nombre d'entre dans la table de partition
NB_READ_TRY	EQU	5	; nombre maximum de lecture du secteur de boot
PART_OFF	EQU	1BEh	; offset de la table de partition dans le
				; secteur de partition
MAGIC_OFF	EQU	7DFEh	; offset du nombre magic 0AA55h


SEGMENT BOOT public 'CODE'

		ASSUME cs:BOOT		     ; Au dbut on est en 7C00h mais
					     ; ca va pas durer

start_boot:
		cli
		xor	ax,ax
		mov	ss,ax
		ASSUME	ss:BOOT
		mov	sp,BIOS_BOOT_OFF     ; On place la pile dans un coin
					     ; Pour l'instant il n'y a que
					     ; le BIOS en mmoire alors on
					     ; a de la place

		mov	si, sp
		push	ax
		pop	es
		push	ax
		pop	ds
		ASSUME	es:BOOT,ds:BOOT
					; Voil tous les registres de segment
					; sont charg

		sti			; et hop on se recopie en 600h
		cld
		mov	di, NEW_BOOT_OFF
		mov	cx, BOOT_SIZE/2
		repne	movsw
		jmp FAR 0:NEW_BOOT_OFF+1Dh ; C'est pas cool les assembleurs qui
					   ; se croient malin....:-(
		ORG	1Dh		   ; vitez d'craser le dbut du
					   ; du programme

start:					; L on commence les choses srieuses

		mov	si, offset Partition_Tab+NEW_BOOT_OFF
		mov	bl, NB_PART

Search_bootable:			; recherche une partition bootable
					; l'etat de la partition peut tre
					;  80h bootable ou 00h non bootable
					; sinon il y a une erreur
                cmp     [(PART_ENTRY PTR si).State], 80h
		jz	Find_Bootable

		cmp	[(PART_ENTRY PTR si).State], 0
		jnz	Part_error
		add	si, SIZE PART_ENTRY
		dec	bl
		jnz	Search_bootable
		int	18h		; Aucune partition bootable
					;  Appel du basic en ROM !!!

Find_Bootable:				; Ouf on a trouv une partition
					; bootable
					; Pour dx il y a une ruse car 80h
					; correspond aussi au premier disque
					; dur

		mov	dx, [word ptr ((PART_ENTRY si).State)]
		mov	cx, [(PART_ENTRY si).StartSector]
		mov	bp, si

Test_part:				; On verifie qu'il y a qu'une partition
					; bootable
		add	si, SIZE PART_ENTRY
		dec	bl
		jz	Only_one_boot
		cmp	[byte ptr si], 0
		jz	Test_part

Part_error:
					; Aih, il y a eut un problme
		mov	si, offset No_Part_msg+NEW_BOOT_OFF

Print_error:				; Affiche un message d'erreur
		lodsb
		cmp	al, 0
		jz	Endless_loop
		push	si		; Affiche un caratre
		mov	bx, 7
		mov	ah, 0Eh
		int	10h
		pop	si
		jmp	Print_error

Endless_loop:				; Quand on a afficher tous le message
					; d'erreur,attend la fin du monde
		jmp	Endless_loop



Only_one_boot:				; Ouf, on a trouv une et une seule
					; partition bootable
		mov	di, NB_READ_TRY
Retry:
		mov	bx,BIOS_BOOT_OFF; Essaye de lire le secteur de boot
		mov	ax,201h		; de la partition choisie
		push	di
		int	13h
		pop	di
		jnb	Load_ok
		xor	ax, ax		; Problme, reset et reessaye
		int	13h
		dec	di
		jnz	Retry
		mov	si, offset Disk_error_msg+NEW_BOOT_OFF
		jmp	Print_error	; Impossible de lire le disque


Load_ok:					; Ouf, on est arriv  lire
						; le secteur de boot
		mov	si, offset No_system_msg+NEW_BOOT_OFF
		mov	di, MAGIC_OFF
		cmp	[word ptr di], 0AA55h
		jnz	Print_error	; damned, il n'est pas executable
		mov	si, bp
		jmp	far ptr	0:7C00h		; C'est fini, on peut aller
						; executer le boot

No_Part_msg     DB 'Table de partition non valide',0
Disk_error_msg  DB 'Erreur au cours du chargement du systme d',27h,'exploitation',0
No_system_msg   DB 'Systme d',27h,'exploitation absent'

		ORG	PART_OFF
Partition_Tab	PART_ENTRY NB_PART DUP (?)
		dw 0AA55h

ENDS

END start_boot
